# Object_Manager.cpp File Reference

`#include "ace/Object_Manager.h"`
`#include "ace/Token_Manager.h"`
`#include "ace/Thread_Manager.h"`
`#include "ace/Service_Manager.h"`
`#include "ace/Service_Config.h"`
`#include "ace/Signal.h"`
`#include "ace/Log_Msg.h"`
`#include "ace/Containers.h"`
`#include "ace/Malloc.h"`
`#include "ace/Framework_Component.h"`
`#include "ace/Atomic_Op.h"`
`#include "ace/OS_NS_sys_time.h"`
`#include "ace/Guard_T.h"`
`#include "ace/Null_Mutex.h"`
`#include "ace/Mutex.h"`
`#include "ace/RW_Thread_Mutex.h"`

Include dependency graph for Object_Manager.cpp:

## Classes

class | ACE_Object_Manager_Preallocations
| Performs preallocations of certain statically allocated services needed by ACE. More...
class | ACE_Object_Manager_Manager
| Ensure that the ACE_Object_Manager gets initialized at program startup, and destroyed at program termination. More...

## Defines

#define | ACE_APPLICATION_PREALLOCATED_OBJECT_DEFINITIONS
#define | ACE_APPLICATION_PREALLOCATED_ARRAY_DEFINITIONS
#define | ACE_APPLICATION_PREALLOCATED_OBJECT_DELETIONS
#define | ACE_APPLICATION_PREALLOCATED_ARRAY_DELETIONS
#define | ACE_PREALLOCATE_OBJECT(TYPE, ID)
#define | ACE_PREALLOCATE_ARRAY(TYPE, ID, COUNT)
#define | ACE_DELETE_PREALLOCATED_OBJECT(TYPE, ID)
#define | ACE_DELETE_PREALLOCATED_ARRAY(TYPE, ID, COUNT)

## Typedefs

typedef ACE_Cleanup_Adapter< ACE_Recursive_Thread_Mutex > | ACE_Static_Object_Lock_Type

## Variables

ACE_Object_Manager_Manager | ACE_Object_Manager_Manager_instance
ACE_Static_Object_Lock_Type * | ACE_Static_Object_Lock_lock = 0

## Define Documentation

#define ACE_APPLICATION_PREALLOCATED_ARRAY_DEFINITIONS

#define ACE_APPLICATION_PREALLOCATED_ARRAY_DELETIONS

#define ACE_APPLICATION_PREALLOCATED_OBJECT_DEFINITIONS

#define ACE_APPLICATION_PREALLOCATED_OBJECT_DELETIONS

#define ACE_DELETE_PREALLOCATED_ARRAY | ( | TYPE,
|  | ID,
|  | COUNT |  | ) |

Value:

    delete (ACE_Cleanup_Adapter<TYPE[COUNT]> *) preallocated_array[ID];\
        preallocated_array[ID] = 0;

#define ACE_DELETE_PREALLOCATED_OBJECT | ( | TYPE,
|  | ID |  | ) |

Value:

    ACE_CLEANUP_DESTROYER_NAME (\
          (ACE_Cleanup_Adapter<TYPE> *) preallocated_object[ID], 0);\
        preallocated_object[ID] = 0;

#define ACE_PREALLOCATE_ARRAY | ( | TYPE,
|  | ID,
|  | COUNT |  | ) |

Value:

    {\
          ACE_Cleanup_Adapter<TYPE[COUNT]> *array_p;\
          ACE_NEW_RETURN (array_p, ACE_Cleanup_Adapter<TYPE[COUNT]>, -1);\
          preallocated_array[ID] = array_p;\
        }

#define ACE_PREALLOCATE_OBJECT | ( | TYPE,
|  | ID |  | ) |

Value:

    {\
          ACE_Cleanup_Adapter<TYPE> *obj_p;\
          ACE_NEW_RETURN (obj_p, ACE_Cleanup_Adapter<TYPE>, -1);\
          preallocated_object[ID] = obj_p;\
        }

## Typedef Documentation

typedef ACE_Cleanup_Adapter<ACE_Recursive_Thread_Mutex> ACE_Static_Object_Lock_Type

## Variable Documentation

ACE_Object_Manager_Manager ACE_Object_Manager_Manager_instance`[static]`

ACE_Static_Object_Lock_Type* ACE_Static_Object_Lock_lock = 0`[static]`